# exceptions.py -- source test pattern for exceptions
#
# This simple program is part of the decompyle test suite.
#
# decompyle is a Python byte-code decompiler
# See http://www.goebel-consult.de/decompyle/ for download and
# for further information

import dis

"""
try = SETUP_EXCEPT stmts POP_BLOCK JUMP_FORWARD except++ COME_FROM
except = 3*POP_TOP stmts JUMP_FORWARD except_else COME_FROM
except_cond = DUP_TOP LOAD_GLOBAL COMPARE_OP JUMP_IF_FALSE 4*POP_TOP stmts JUMP_FORWARD COME_FROM POP_TOP except_else COME_FROM
except_else = END_FINALLY stmts_opt

#exceptseq ::== try finally COME_TO
#exceptseq ::== try exceptstmts COME_TO
#exceptsmts ::= exceptstmts except
#exceptsmts ::= except
#exceptsmts ::= cond_except
#try : SETUP_EXCEPT stmts_opt POP_BLOCK JUMP_FORWARD except|exceptcond COME_TO
#excetp: COME_TO POP_TOP POP_TOP POP_TOP stmts_opt JMP_FORWARD END_FINALLY COME_TO
#exctest: COME_TO DUP_TOP LOAD_GLOBAL COMPARE_OP JUMP_IF_FALSE 4*POP_TOP stmts_opt JUMP_FORWARD   except??|exceptcond|except_else COME_TO
#
#except_else = COME_TO POP_TOP END_FINALLY

#trystmt     ::= SETUP_EXCEPT stmts_opt POP_BLOCK JUMP_FORWARD
#COME_FROM POP_TOP POP_TOP POP_TOP stmts_opt JUMP_FORWARD END_FINALLY
#COME_FROM COME_FROM
#
#tryelsestmt ::= SETUP_EXCEPT stmts_opt POP_BLOCK JUMP_FORWARD
#COME_FROM POP_TOP POP_TOP POP_TOP stmts_opt JUMP_FORWARD END_FINALLY
#COME_FROM stmts COME_FROM
"""

def x11():
	try:
		a = 'try except'
	except:
		a = 2

	b = '--------'

def x12():
	try:
		a = 'try except else(pass)'
	except:
		a = 2
	else:
		pass

	b = '--------'

def x13():
	try:
		a = 'try except else(a=3)'
	except:
		a = 2
	else:
		a = 3

	b = '--------'

def x21():
	try:
		a = 'try KeyError'
	except KeyError:
		a = 8

	b = '--------'

def x22():
	try:
		a = 'try (IdxErr, KeyError) else(pass)'
	except (IndexError, KeyError):
		a = 8
	else:
		pass

	b = '--------'

def x23():
	try:
		a = 'try KeyError else(a=9)'
	except KeyError:
		a = 8
	else:
		a = 9

	b = '--------'

def x31():
	try:
		a = 'try KeyError IndexError'
	except KeyError:
		a = 8
	except IndexError:
		a = 9

	b = '--------'

def x32():
	try:
		a = 'try KeyError IndexError else(pass)'
	except KeyError:
		a = 8
	except IndexError:
		a = 9
	else:
		pass

	b = '--------'

def x33():
	try:
		a = 'try KeyError IndexError else(a=9)'
	except KeyError:
		a = 8
	except IndexError:
		a = 9
	else:
		a = 9

	b = '#################'

def x41():
	if a == 1:
		a = 1
	elif b == 1:
		b = 1
	else:
		c = 1
	b = '#################'

def x42():
	if a == 1:
		a = 1
	else:
		if b == 1:
			b = 1
		else:
			c = 1

	xxx='mmm'


if __name__ == '__main__':
	dis.dis(xx)
